theory GHCGoals
imports Main GHCTest GHCRewriteSystem
begin

lemma Challenge1a :
"\<exists> v r. evaluateN (Challenge1a xs lengths) v = IsWHNF r" oops


(* Challenge 1: prove termination of the following terms, for all lengths and xs:

1a. foldr (.) id (map drop lengths) xs
1b. drop (foldr (+) 0 lengths) xs

For any lengths,xs :: List Nat

Challenge 2 (harder): prove non-termination of the first, and termination on the second: (aprove gives maybe on both)

let listOf n = n:foldr (.) id (map take (listOf n)) (listOf n)
in listOf x

// and the following will terminate, yielding a list of x elements (all x),
// but this cannot be shown by aprove (and it is very slow: listOf 11 takes 11 secs, listOf 12 takes 12 times that amount)
let listOf n = n:foldr (.) id (map take (listOf (n - 1))) (listOf n)
in listOf x

For any x :: Nat

Challenge 3:

Follow the aprove proof for the following (Uses nonempty P Q R in a step):
drop (sum lengths) xs

Challenge 4 (modularity):
- show equivalence of "sum" (shown below) and "foldr (+) 0"
- show that substitution of such equivalences preserves termination
- proof termination of Challenge 3 using the aprove proof of Challenge 1

import qualified Prelude

data Nat = S Nat | Z 
data List a = Cons a (List a) | Nil 

// not sure which definition aprove uses for (-), we get a null pointer exception on:

take Z xs = Nil
take n Nil = Nil
take (S n) (Cons x xs) = Cons x (take (p(S n)) xs)

map f Nil = Nil
map f (Cons x xs) = Cons (f x) (map f xs)

foldr f z [] = z
foldr f z (Cons x xs) = f x (foldr f z xs)

(.) f g x = f (g x)

drop Z xs = xs
drop (S n) (Cons x xs) = drop n xs
drop _ Nil = Nil // note that the first pattern match is on the left argument

*)
