{-# LANGUAGE EmptyDataDecls, RankNTypes, ScopedTypeVariables #-}

module Finite_Set(finite) where {

import Prelude ((==), (/=), (<), (<=), (>=), (>), (+), (-), (*), (/), (**),
  (>>=), (>>), (=<<), (&&), (||), (^), (^^), (.), ($), ($!), (++), (!!), Eq,
  error, id, return, not, fst, snd, map, filter, concat, concatMap, reverse,
  zip, null, takeWhile, dropWhile, all, any, Integer, negate, abs, divMod,
  String, Bool(True, False), Maybe(Nothing, Just));
import qualified Prelude;
import qualified Uint;
import qualified Array;
import qualified Uint32;
import qualified Uint64;
import qualified Data_Bits;
import qualified Option;
import qualified RBT_Mapping2;
import qualified Phantom_Type;
import qualified DList_Set;
import qualified Comparator;
import qualified Set;
import qualified Collection_Order;
import qualified Cardinality;
import qualified Collection_Eq;

finite ::
  forall a.
    (Cardinality.Finite_UNIV a, Collection_Eq.Ceq a,
      Collection_Order.Ccompare a) => Set.Set a -> Bool;
finite (Set.Collect_set p) =
  Phantom_Type.of_phantom
    (Cardinality.finite_UNIV :: Phantom_Type.Phantom a Bool) ||
    (error :: forall a. String -> (() -> a) -> a) "finite Collect_set"
      (\ _ -> finite (Set.Collect_set p));
finite (Set.Set_Monad xs) = True;
finite (Set.Complement a) =
  (if Phantom_Type.of_phantom
        (Cardinality.finite_UNIV :: Phantom_Type.Phantom a Bool)
    then True
    else (if finite a then False
           else (error :: forall a. String -> (() -> a) -> a)
                  "finite Complement: infinite set"
                  (\ _ -> finite (Set.Complement a))));
finite (Set.RBT_set rbt) =
  (case (Collection_Order.ccompare :: Maybe (a -> a -> Comparator.Order)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "finite RBT_set: ccompare = None" (\ _ -> finite (Set.RBT_set rbt));
    Just _ -> True;
  });
finite (Set.DList_set dxs) =
  (case (Collection_Eq.ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "finite DList_set: ceq = None" (\ _ -> finite (Set.DList_set dxs));
    Just _ -> True;
  });

}
